﻿using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;

namespace MyTests.Pages
{
    // Страница с результатом прохождения теста
    public partial class ResultTestPage : Page
    {
        public ResultTestPage()
        {
            InitializeComponent();

            if (Session.OpenedTest.IsAnswersVisible == true) // Если включен просмотр ответов
                CheckAnswersButton.Visibility = Visibility.Visible; // Кнопка просмотра ответов становится видна
            ResultTB.Text = $"{Session.Points}/{Session.OpenedTest.Questions.Count}"; // Вывод результата пользователя
        }

        private void AnswersButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new CheckTestResults(Session.OpenedTest, Session.User)); // Переход на страницу просмотра результатов
        }

        private void ExitButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new TestsCatalog()); // Переход на страницу с каталогом тестов
        }
        private void ProfileButton_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new ProfilePage(cdb.db.Users.Where(item => item.IdUser == Session.OpenedTest.IdUser).FirstOrDefault())); // Переход на страницу с профилем
        }
    }
}
